1#!/bin/sh
2#
3# git-submodule.sh: add, init, update or list git submodules
4#
5# Copyright (c) 2007 Lars Hjemli
6
7dashless=$(basename "$0" | sed -e 's/-/ /')
8USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
14 or: $dashless [--quiet] foreach [--recursive] <command>
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
16 or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
17OPTIONS_SPEC=
18SUBDIRECTORY_OK=Yes
19. git-sh-setup
20. git-parse-remote
21require_work_tree
22wt_prefix=$(git rev-parse --show-prefix)
23cd_to_toplevel
24
25# Tell the rest of git that any URLs we get don't come
26# directly from the user, so it can apply policy as appropriate.
27GIT_PROTOCOL_FROM_USER=0
28export GIT_PROTOCOL_FROM_USER
29
30command=
31branch=
32force=
33reference=
34cached=
35recursive=
36init=
37files=
38remote=
39nofetch=
40update=
41prefix=
42custom_name=
43depth=
44progress=
45dissociate=
46
47die_if_unmatched ()
48{
49 if test "$1" = "#unmatched"
50 then
51 exit ${2:-1}
52 fi
53}
54
55#
56# Print a submodule configuration setting
57#
58# $1 = submodule name
59# $2 = option name
60# $3 = default value
61#
62# Checks in the usual git-config places first (for overrides),
63# otherwise it falls back on .gitmodules. This allows you to
64# distribute project-wide defaults in .gitmodules, while still
65# customizing individual repositories if necessary. If the option is
66# not in .gitmodules either, print a default value.
67#
68get_submodule_config () {
69 name="$1"
70 option="$2"
71 default="$3"
72 value=$(git config submodule."$name"."$option")
73 if test -z "$value"
74 then
75 value=$(git config -f .gitmodules submodule."$name"."$option")
76 fi
77 printf '%s' "${value:-$default}"
78}
79
80isnumber()
81{
82 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
83}
84
85# Sanitize the local git environment for use within a submodule. We
86# can't simply use clear_local_git_env since we want to preserve some
87# of the settings from GIT_CONFIG_PARAMETERS.
88sanitize_submodule_env()
89{
90 save_config=$GIT_CONFIG_PARAMETERS
91 clear_local_git_env
92 GIT_CONFIG_PARAMETERS=$save_config
93 export GIT_CONFIG_PARAMETERS
94}
95
96#
97# Add a new submodule to the working tree, .gitmodules and the index
98#
99# $@ = repo path
100#
101# optional branch is stored in global branch variable
102#
103cmd_add()
104{
105 # parse $args after "submodule ... add".
106 reference_path=
107 while test $# -ne 0
108 do
109 case "$1" in
110 -b | --branch)
111 case "$2" in '') usage ;; esac
112 branch=$2
113 shift
114 ;;
115 -f | --force)
116 force=$1
117 ;;
118 -q|--quiet)
119 GIT_QUIET=1
120 ;;
121 --progress)
122 progress=1
123 ;;
124 --reference)
125 case "$2" in '') usage ;; esac
126 reference_path=$2
127 shift
128 ;;
129 --reference=*)
130 reference_path="${1#--reference=}"
131 ;;
132 --dissociate)
133 dissociate=1
134 ;;
135 --name)
136 case "$2" in '') usage ;; esac
137 custom_name=$2
138 shift
139 ;;
140 --depth)
141 case "$2" in '') usage ;; esac
142 depth="--depth=$2"
143 shift
144 ;;
145 --depth=*)
146 depth=$1
147 ;;
148 --)
149 shift
150 break
151 ;;
152 -*)
153 usage
154 ;;
155 *)
156 break
157 ;;
158 esac
159 shift
160 done
161
162 if test -n "$reference_path"
163 then
164 is_absolute_path "$reference_path" ||
165 reference_path="$wt_prefix$reference_path"
166
167 reference="--reference=$reference_path"
168 fi
169
170 repo=$1
171 sm_path=$2
172
173 if test -z "$sm_path"; then
174 sm_path=$(printf '%s\n' "$repo" |
175 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
176 fi
177
178 if test -z "$repo" || test -z "$sm_path"; then
179 usage
180 fi
181
182 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
183
184 # assure repo is absolute or relative to parent
185 case "$repo" in
186 ./*|../*)
187 test -z "$wt_prefix" ||
188 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
189
190 # dereference source url relative to parent's url
191 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
192 ;;
193 *:*|/*)
194 # absolute url
195 realrepo=$repo
196 ;;
197 *)
198 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
199 ;;
200 esac
201
202 # normalize path:
203 # multiple //; leading ./; /./; /../; trailing /
204 sm_path=$(printf '%s/\n' "$sm_path" |
205 sed -e '
206 s|//*|/|g
207 s|^\(\./\)*||
208 s|/\(\./\)*|/|g
209 :start
210 s|\([^/]*\)/\.\./||
211 tstart
212 s|/*$||
213 ')
214 if test -z "$force"
215 then
216 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
217 die "$(eval_gettext "'\$sm_path' already exists in the index")"
218 else
219 git ls-files -s "$sm_path" | sane_grep -v "^160000" > /dev/null 2>&1 &&
220 die "$(eval_gettext "'\$sm_path' already exists in the index and is not a submodule")"
221 fi
222
223 if test -z "$force" &&
224 ! git add --dry-run --ignore-missing --no-warn-embedded-repo "$sm_path" > /dev/null 2>&1
225 then
226 eval_gettextln "The following path is ignored by one of your .gitignore files:
227\$sm_path
228Use -f if you really want to add it." >&2
229 exit 1
230 fi
231
232 if test -n "$custom_name"
233 then
234 sm_name="$custom_name"
235 else
236 sm_name="$sm_path"
237 fi
238
239 if ! git submodule--helper check-name "$sm_name"
240 then
241 die "$(eval_gettext "'$sm_name' is not a valid submodule name")"
242 fi
243
244 # perhaps the path exists and is already a git repo, else clone it
245 if test -e "$sm_path"
246 then
247 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
248 then
249 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
250 else
251 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
252 fi
253
254 else
255 if test -d ".git/modules/$sm_name"
256 then
257 if test -z "$force"
258 then
259 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
260 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
261 die "$(eval_gettextln "\
262If you want to reuse this local git directory instead of cloning again from
263 \$realrepo
264use the '--force' option. If the local git directory is not the correct repo
265or you are unsure what this means choose another name with the '--name' option.")"
266 else
267 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
268 fi
269 fi
270 git submodule--helper clone ${GIT_QUIET:+--quiet} ${progress:+"--progress"} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${dissociate:+"--dissociate"} ${depth:+"$depth"} || exit
271 (
272 sanitize_submodule_env
273 cd "$sm_path" &&
274 # ash fails to wordsplit ${branch:+-b "$branch"...}
275 case "$branch" in
276 '') git checkout -f -q ;;
277 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
278 esac
279 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
280 fi
281 git config submodule."$sm_name".url "$realrepo"
282
283 git add --no-warn-embedded-repo $force "$sm_path" ||
284 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
285
286 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
287 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
288 if test -n "$branch"
289 then
290 git config -f .gitmodules submodule."$sm_name".branch "$branch"
291 fi &&
292 git add --force .gitmodules ||
293 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
294
295 # NEEDSWORK: In a multi-working-tree world, this needs to be
296 # set in the per-worktree config.
297 if git config --get submodule.active >/dev/null
298 then
299 # If the submodule being adding isn't already covered by the
300 # current configured pathspec, set the submodule's active flag
301 if ! git submodule--helper is-active "$sm_path"
302 then
303 git config submodule."$sm_name".active "true"
304 fi
305 else
306 git config submodule."$sm_name".active "true"
307 fi
308}
309
310#
311# Execute an arbitrary command sequence in each checked out
312# submodule
313#
314# $@ = command to execute
315#
316cmd_foreach()
317{
318 # parse $args after "submodule ... foreach".
319 while test $# -ne 0
320 do
321 case "$1" in
322 -q|--quiet)
323 GIT_QUIET=1
324 ;;
325 --recursive)
326 recursive=1
327 ;;
328 -*)
329 usage
330 ;;
331 *)
332 break
333 ;;
334 esac
335 shift
336 done
337
338 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper foreach ${GIT_QUIET:+--quiet} ${recursive:+--recursive} "$@"
339}
340
341#
342# Register submodules in .git/config
343#
344# $@ = requested paths (default to all)
345#
346cmd_init()
347{
348 # parse $args after "submodule ... init".
349 while test $# -ne 0
350 do
351 case "$1" in
352 -q|--quiet)
353 GIT_QUIET=1
354 ;;
355 --)
356 shift
357 break
358 ;;
359 -*)
360 usage
361 ;;
362 *)
363 break
364 ;;
365 esac
366 shift
367 done
368
369 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet} "$@"
370}
371
372#
373# Unregister submodules from .git/config and remove their work tree
374#
375cmd_deinit()
376{
377 # parse $args after "submodule ... deinit".
378 deinit_all=
379 while test $# -ne 0
380 do
381 case "$1" in
382 -f|--force)
383 force=$1
384 ;;
385 -q|--quiet)
386 GIT_QUIET=1
387 ;;
388 --all)
389 deinit_all=t
390 ;;
391 --)
392 shift
393 break
394 ;;
395 -*)
396 usage
397 ;;
398 *)
399 break
400 ;;
401 esac
402 shift
403 done
404
405 git ${wt_prefix:+-C "$wt_prefix"} submodule--helper deinit ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} ${force:+--force} ${deinit_all:+--all} "$@"
406}
407
408is_tip_reachable () (
409 sanitize_submodule_env &&
410 cd "$1" &&
411 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
412 test -z "$rev"
413)
414
415fetch_in_submodule () (
416 sanitize_submodule_env &&
417 cd "$1" &&
418 case "$2" in
419 '')
420 git fetch ;;
421 *)
422 shift
423 git fetch $(get_default_remote) "$@" ;;
424 esac
425)
426
427#
428# Update each submodule path to correct revision, using clone and checkout as needed
429#
430# $@ = requested paths (default to all)
431#
432cmd_update()
433{
434 # parse $args after "submodule ... update".
435 while test $# -ne 0
436 do
437 case "$1" in
438 -q|--quiet)
439 GIT_QUIET=1
440 ;;
441 --progress)
442 progress=1
443 ;;
444 -i|--init)
445 init=1
446 ;;
447 --remote)
448 remote=1
449 ;;
450 -N|--no-fetch)
451 nofetch=1
452 ;;
453 -f|--force)
454 force=$1
455 ;;
456 -r|--rebase)
457 update="rebase"
458 ;;
459 --reference)
460 case "$2" in '') usage ;; esac
461 reference="--reference=$2"
462 shift
463 ;;
464 --reference=*)
465 reference="$1"
466 ;;
467 --dissociate)
468 dissociate=1
469 ;;
470 -m|--merge)
471 update="merge"
472 ;;
473 --recursive)
474 recursive=1
475 ;;
476 --checkout)
477 update="checkout"
478 ;;
479 --recommend-shallow)
480 recommend_shallow="--recommend-shallow"
481 ;;
482 --no-recommend-shallow)
483 recommend_shallow="--no-recommend-shallow"
484 ;;
485 --depth)
486 case "$2" in '') usage ;; esac
487 depth="--depth=$2"
488 shift
489 ;;
490 --depth=*)
491 depth=$1
492 ;;
493 -j|--jobs)
494 case "$2" in '') usage ;; esac
495 jobs="--jobs=$2"
496 shift
497 ;;
498 --jobs=*)
499 jobs=$1
500 ;;
501 --)
502 shift
503 break
504 ;;
505 -*)
506 usage
507 ;;
508 *)
509 break
510 ;;
511 esac
512 shift
513 done
514
515 if test -n "$init"
516 then
517 cmd_init "--" "$@" || return
518 fi
519
520 {
521 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
522 ${progress:+"--progress"} \
523 ${wt_prefix:+--prefix "$wt_prefix"} \
524 ${prefix:+--recursive-prefix "$prefix"} \
525 ${update:+--update "$update"} \
526 ${reference:+"$reference"} \
527 ${dissociate:+"--dissociate"} \
528 ${depth:+--depth "$depth"} \
529 $recommend_shallow \
530 $jobs \
531 "$@" || echo "#unmatched" $?
532 } | {
533 err=
534 while read -r quickabort sha1 just_cloned sm_path
535 do
536 die_if_unmatched "$quickabort" "$sha1"
537
538 git submodule--helper ensure-core-worktree "$sm_path"
539
540 name=$(git submodule--helper name "$sm_path") || exit
541 if ! test -z "$update"
542 then
543 update_module=$update
544 else
545 update_module=$(git config submodule."$name".update)
546 if test -z "$update_module"
547 then
548 update_module="checkout"
549 fi
550 fi
551
552 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
553
554 if test $just_cloned -eq 1
555 then
556 subsha1=
557 case "$update_module" in
558 merge | rebase | none)
559 update_module=checkout ;;
560 esac
561 else
562 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
563 git rev-parse --verify HEAD) ||
564 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
565 fi
566
567 if test -n "$remote"
568 then
569 branch=$(git submodule--helper remote-branch "$sm_path")
570 if test -z "$nofetch"
571 then
572 # Fetch remote before determining tracking $sha1
573 fetch_in_submodule "$sm_path" $depth ||
574 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
575 fi
576 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
577 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
578 git rev-parse --verify "${remote_name}/${branch}") ||
579 die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
580 fi
581
582 if test "$subsha1" != "$sha1" || test -n "$force"
583 then
584 subforce=$force
585 # If we don't already have a -f flag and the submodule has never been checked out
586 if test -z "$subsha1" && test -z "$force"
587 then
588 subforce="-f"
589 fi
590
591 if test -z "$nofetch"
592 then
593 # Run fetch only if $sha1 isn't present or it
594 # is not reachable from a ref.
595 is_tip_reachable "$sm_path" "$sha1" ||
596 fetch_in_submodule "$sm_path" $depth ||
597 say "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
598
599 # Now we tried the usual fetch, but $sha1 may
600 # not be reachable from any of the refs
601 is_tip_reachable "$sm_path" "$sha1" ||
602 fetch_in_submodule "$sm_path" $depth "$sha1" ||
603 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
604 fi
605
606 must_die_on_failure=
607 case "$update_module" in
608 checkout)
609 command="git checkout $subforce -q"
610 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
611 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
612 ;;
613 rebase)
614 command="git rebase"
615 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
616 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
617 must_die_on_failure=yes
618 ;;
619 merge)
620 command="git merge"
621 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
622 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
623 must_die_on_failure=yes
624 ;;
625 !*)
626 command="${update_module#!}"
627 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
628 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
629 must_die_on_failure=yes
630 ;;
631 *)
632 die "$(eval_gettext "Invalid update mode '$update_module' for submodule path '$path'")"
633 esac
634
635 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
636 then
637 say "$say_msg"
638 elif test -n "$must_die_on_failure"
639 then
640 die_with_status 2 "$die_msg"
641 else
642 err="${err};$die_msg"
643 continue
644 fi
645 fi
646
647 if test -n "$recursive"
648 then
649 (
650 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
651 wt_prefix=
652 sanitize_submodule_env
653 cd "$sm_path" &&
654 eval cmd_update
655 )
656 res=$?
657 if test $res -gt 0
658 then
659 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
660 if test $res -ne 2
661 then
662 err="${err};$die_msg"
663 continue
664 else
665 die_with_status $res "$die_msg"
666 fi
667 fi
668 fi
669 done
670
671 if test -n "$err"
672 then
673 OIFS=$IFS
674 IFS=';'
675 for e in $err
676 do
677 if test -n "$e"
678 then
679 echo >&2 "$e"
680 fi
681 done
682 IFS=$OIFS
683 exit 1
684 fi
685 }
686}
687
688#
689# Show commit summary for submodules in index or working tree
690#
691# If '--cached' is given, show summary between index and given commit,
692# or between working tree and given commit
693#
694# $@ = [commit (default 'HEAD'),] requested paths (default all)
695#
696cmd_summary() {
697 summary_limit=-1
698 for_status=
699 diff_cmd=diff-index
700
701 # parse $args after "submodule ... summary".
702 while test $# -ne 0
703 do
704 case "$1" in
705 --cached)
706 cached="$1"
707 ;;
708 --files)
709 files="$1"
710 ;;
711 --for-status)
712 for_status="$1"
713 ;;
714 -n|--summary-limit)
715 summary_limit="$2"
716 isnumber "$summary_limit" || usage
717 shift
718 ;;
719 --summary-limit=*)
720 summary_limit="${1#--summary-limit=}"
721 isnumber "$summary_limit" || usage
722 ;;
723 --)
724 shift
725 break
726 ;;
727 -*)
728 usage
729 ;;
730 *)
731 break
732 ;;
733 esac
734 shift
735 done
736
737 test $summary_limit = 0 && return
738
739 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
740 then
741 head=$rev
742 test $# = 0 || shift
743 elif test -z "$1" || test "$1" = "HEAD"
744 then
745 # before the first commit: compare with an empty tree
746 head=$(git hash-object -w -t tree --stdin </dev/null)
747 test -z "$1" || shift
748 else
749 head="HEAD"
750 fi
751
752 if [ -n "$files" ]
753 then
754 test -n "$cached" &&
755 die "$(gettext "The --cached option cannot be used with the --files option")"
756 diff_cmd=diff-files
757 head=
758 fi
759
760 cd_to_toplevel
761 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
762 # Get modified modules cared by user
763 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
764 sane_egrep '^:([0-7]* )?160000' |
765 while read -r mod_src mod_dst sha1_src sha1_dst status sm_path
766 do
767 # Always show modules deleted or type-changed (blob<->module)
768 if test "$status" = D || test "$status" = T
769 then
770 printf '%s\n' "$sm_path"
771 continue
772 fi
773 # Respect the ignore setting for --for-status.
774 if test -n "$for_status"
775 then
776 name=$(git submodule--helper name "$sm_path")
777 ignore_config=$(get_submodule_config "$name" ignore none)
778 test $status != A && test $ignore_config = all && continue
779 fi
780 # Also show added or modified modules which are checked out
781 GIT_DIR="$sm_path/.git" git rev-parse --git-dir >/dev/null 2>&1 &&
782 printf '%s\n' "$sm_path"
783 done
784 )
785
786 test -z "$modules" && return
787
788 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
789 sane_egrep '^:([0-7]* )?160000' |
790 cut -c2- |
791 while read -r mod_src mod_dst sha1_src sha1_dst status name
792 do
793 if test -z "$cached" &&
794 test $sha1_dst = 0000000000000000000000000000000000000000
795 then
796 case "$mod_dst" in
797 160000)
798 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
799 ;;
800 100644 | 100755 | 120000)
801 sha1_dst=$(git hash-object $name)
802 ;;
803 000000)
804 ;; # removed
805 *)
806 # unexpected type
807 eval_gettextln "unexpected mode \$mod_dst" >&2
808 continue ;;
809 esac
810 fi
811 missing_src=
812 missing_dst=
813
814 test $mod_src = 160000 &&
815 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_src^0 >/dev/null &&
816 missing_src=t
817
818 test $mod_dst = 160000 &&
819 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_dst^0 >/dev/null &&
820 missing_dst=t
821
822 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
823
824 total_commits=
825 case "$missing_src,$missing_dst" in
826 t,)
827 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
828 ;;
829 ,t)
830 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
831 ;;
832 t,t)
833 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
834 ;;
835 *)
836 errmsg=
837 total_commits=$(
838 if test $mod_src = 160000 && test $mod_dst = 160000
839 then
840 range="$sha1_src...$sha1_dst"
841 elif test $mod_src = 160000
842 then
843 range=$sha1_src
844 else
845 range=$sha1_dst
846 fi
847 GIT_DIR="$name/.git" \
848 git rev-list --first-parent $range -- | wc -l
849 )
850 total_commits=" ($(($total_commits + 0)))"
851 ;;
852 esac
853
854 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
855 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
856 if test $status = T
857 then
858 blob="$(gettext "blob")"
859 submodule="$(gettext "submodule")"
860 if test $mod_dst = 160000
861 then
862 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
863 else
864 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
865 fi
866 else
867 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
868 fi
869 if test -n "$errmsg"
870 then
871 # Don't give error msg for modification whose dst is not submodule
872 # i.e. deleted or changed to blob
873 test $mod_dst = 160000 && echo "$errmsg"
874 else
875 if test $mod_src = 160000 && test $mod_dst = 160000
876 then
877 limit=
878 test $summary_limit -gt 0 && limit="-$summary_limit"
879 GIT_DIR="$name/.git" \
880 git log $limit --pretty='format: %m %s' \
881 --first-parent $sha1_src...$sha1_dst
882 elif test $mod_dst = 160000
883 then
884 GIT_DIR="$name/.git" \
885 git log --pretty='format: > %s' -1 $sha1_dst
886 else
887 GIT_DIR="$name/.git" \
888 git log --pretty='format: < %s' -1 $sha1_src
889 fi
890 echo
891 fi
892 echo
893 done
894}
895#
896# List all submodules, prefixed with:
897# - submodule not initialized
898# + different revision checked out
899#
900# If --cached was specified the revision in the index will be printed
901# instead of the currently checked out revision.
902#
903# $@ = requested paths (default to all)
904#
905cmd_status()
906{
907 # parse $args after "submodule ... status".
908 while test $# -ne 0
909 do
910 case "$1" in
911 -q|--quiet)
912 GIT_QUIET=1
913 ;;
914 --cached)
915 cached=1
916 ;;
917 --recursive)
918 recursive=1
919 ;;
920 --)
921 shift
922 break
923 ;;
924 -*)
925 usage
926 ;;
927 *)
928 break
929 ;;
930 esac
931 shift
932 done
933
934 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper status ${GIT_QUIET:+--quiet} ${cached:+--cached} ${recursive:+--recursive} "$@"
935}
936#
937# Sync remote urls for submodules
938# This makes the value for remote.$remote.url match the value
939# specified in .gitmodules.
940#
941cmd_sync()
942{
943 while test $# -ne 0
944 do
945 case "$1" in
946 -q|--quiet)
947 GIT_QUIET=1
948 shift
949 ;;
950 --recursive)
951 recursive=1
952 shift
953 ;;
954 --)
955 shift
956 break
957 ;;
958 -*)
959 usage
960 ;;
961 *)
962 break
963 ;;
964 esac
965 done
966
967 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper sync ${GIT_QUIET:+--quiet} ${recursive:+--recursive} "$@"
968}
969
970cmd_absorbgitdirs()
971{
972 git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
973}
974
975# This loop parses the command line arguments to find the
976# subcommand name to dispatch. Parsing of the subcommand specific
977# options are primarily done by the subcommand implementations.
978# Subcommand specific options such as --branch and --cached are
979# parsed here as well, for backward compatibility.
980
981while test $# != 0 && test -z "$command"
982do
983 case "$1" in
984 add | foreach | init | deinit | update | status | summary | sync | absorbgitdirs)
985 command=$1
986 ;;
987 -q|--quiet)
988 GIT_QUIET=1
989 ;;
990 -b|--branch)
991 case "$2" in
992 '')
993 usage
994 ;;
995 esac
996 branch="$2"; shift
997 ;;
998 --cached)
999 cached="$1"
1000 ;;
1001 --)
1002 break
1003 ;;
1004 -*)
1005 usage
1006 ;;
1007 *)
1008 break
1009 ;;
1010 esac
1011 shift
1012done
1013
1014# No command word defaults to "status"
1015if test -z "$command"
1016then
1017 if test $# = 0
1018 then
1019 command=status
1020 else
1021 usage
1022 fi
1023fi
1024
1025# "-b branch" is accepted only by "add"
1026if test -n "$branch" && test "$command" != add
1027then
1028 usage
1029fi
1030
1031# "--cached" is accepted only by "status" and "summary"
1032if test -n "$cached" && test "$command" != status && test "$command" != summary
1033then
1034 usage
1035fi
1036
1037"cmd_$command" "$@"